diff --git a/gnome-session/gsm-manager.c b/gnome-session/gsm-manager.c
index b7f1788e..743a372e 100644
--- a/gnome-session/gsm-manager.c
+++ b/gnome-session/gsm-manager.c
@@ -918,17 +1680,54 @@ _disconnect_client (GsmManager *manager,
                  * in library code after the callback. Or maybe the application
                  * crashed while handling EndSession. Or it was lazy.
                  */
-                on_client_end_session_response (client,
-                                                TRUE,
-                                                "Client exited in end session "
-                                                "phase without sending "
-                                                "EndSessionResponse",
-                                                manager);
+                _handle_client_end_session_response (manager,
+                                                     client,
+                                                     TRUE,
+                                                     FALSE,
+                                                     FALSE,
+                                                     "Client exited in "
+                                                     "end session phase without "
+                                                     "sending EndSessionResponse");
         default:
                 /* do nothing */
                 break;
         }
 
+        if (priv->dbus_disconnected && GSM_IS_DBUS_CLIENT (client)) {
+                g_debug ("GsmManager: dbus disconnected, not restarting application");
+                goto out;
+        }
+
+        if (app == NULL) {
+                g_debug ("GsmManager: unable to find application for client - not restarting");
+                goto out;
+        }
+
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+                g_debug ("GsmManager: in shutdown, not restarting application");
+                goto out;
+        }
+
+        app_restart = gsm_app_peek_autorestart (app);
+        client_restart_hint = gsm_client_peek_restart_style_hint (client);
+
+        /* allow legacy clients to override the app info */
+        if (! app_restart
+            && client_restart_hint != GSM_CLIENT_RESTART_IMMEDIATELY) {
+                g_debug ("GsmManager: autorestart not set, not restarting application");
+                goto out;
+        }
+
+        if (is_condition_client) {
+                g_debug ("GsmManager: app conditionally disabled, not restarting application");
+                goto out;
+        }
+
+        g_debug ("GsmManager: restarting app");
+
+        _restart_app (manager, app);
+
+ out:
         g_object_unref (client);
 }
 
@@ -944,13 +1743,17 @@ _disconnect_dbus_client (const char       *id,
 {
         const char *name;
 
+        if (! GSM_IS_DBUS_CLIENT (client)) {
+                return FALSE;
+        }
+
         /* If no service name, then we simply disconnect all clients */
         if (!data->service_name) {
                 _disconnect_client (data->manager, client);
                 return TRUE;
         }
 
-        name = gsm_client_peek_bus_name (client);
+        name = gsm_dbus_client_get_bus_name (GSM_DBUS_CLIENT (client));
         if (IS_STRING_EMPTY (name)) {
                 return FALSE;
         }
@@ -976,96 +1779,195 @@ static void
 remove_clients_for_connection (GsmManager *manager,
                                const char *service_name)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         RemoveClientData data;
 
         data.service_name = service_name;
         data.manager = manager;
 
         /* disconnect dbus clients for name */
-        gsm_store_foreach_remove (manager->clients,
+        gsm_store_foreach_remove (priv->clients,
                                   (GsmStoreFunc)_disconnect_dbus_client,
                                   &data);
 
-        if (manager->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION
-            && gsm_store_size (manager->clients) == 0) {
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION
+            && gsm_store_size (priv->clients) == 0) {
                 g_debug ("GsmManager: last client disconnected - exiting");
                 end_phase (manager);
         }
 }
 
+static void
+gsm_manager_set_failsafe (GsmManager *manager,
+                          gboolean    enabled)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_return_if_fail (GSM_IS_MANAGER (manager));
+
+        priv->failsafe = enabled;
+}
+
 gboolean
 gsm_manager_get_dbus_disconnected (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_return_val_if_fail (GSM_IS_MANAGER (manager), FALSE);
 
-        return manager->dbus_disconnected;
+        return priv->dbus_disconnected;
+}
+
+gboolean
+gsm_manager_get_failsafe (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_return_val_if_fail (GSM_IS_MANAGER (manager), FALSE);
+
+        return priv->failsafe;
+}
+
+gboolean
+gsm_manager_get_systemd_managed (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_return_val_if_fail (GSM_IS_MANAGER (manager), FALSE);
+
+        return priv->systemd_managed;
 }
 
 static void
 on_client_disconnected (GsmClient  *client,
                         GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: disconnect client");
         _disconnect_client (manager, client);
-        gsm_store_remove (manager->clients, gsm_client_peek_id (client));
-        if (manager->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION
-            && gsm_store_size (manager->clients) == 0) {
+        gsm_store_remove (priv->clients, gsm_client_peek_id (client));
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION
+            && gsm_store_size (priv->clients) == 0) {
                 g_debug ("GsmManager: last client disconnected - exiting");
                 end_phase (manager);
         }
 }
 
 static void
-on_client_end_session_response (GsmClient  *client,
-                                gboolean    is_ok,
-                                const char *reason,
-                                GsmManager *manager)
+_handle_client_end_session_response (GsmManager *manager,
+                                     GsmClient  *client,
+                                     gboolean    is_ok,
+                                     gboolean    do_last,
+                                     gboolean    cancel,
+                                     const char *reason)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         /* just ignore if received outside of shutdown */
-        if (manager->phase < GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+        if (priv->phase < GSM_MANAGER_PHASE_QUERY_END_SESSION) {
                 return;
         }
 
-        g_debug ("GsmManager: Response from end session request: is-ok=%d reason=%s", is_ok, reason ?: "(none)");
+        g_debug ("GsmManager: Response from end session request: is-ok=%d do-last=%d cancel=%d reason=%s", is_ok, do_last, cancel, reason ? reason :"");
+
+        if (cancel) {
+                cancel_end_session (manager);
+                return;
+        }
 
-        manager->query_clients = g_slist_remove (manager->query_clients, client);
+        priv->query_clients = g_slist_remove (priv->query_clients, client);
 
-        if (!is_ok && manager->logout_mode != GSM_MANAGER_LOGOUT_MODE_FORCE) {
+        if (! is_ok && priv->logout_mode != GSM_MANAGER_LOGOUT_MODE_FORCE) {
+                guint         cookie;
                 GsmInhibitor *inhibitor;
+                char         *app_id;
+                const char   *bus_name;
+
+                /* FIXME: do we support updating the reason? */
 
                 /* Create JIT inhibit */
+                if (GSM_IS_DBUS_CLIENT (client)) {
+                        bus_name = gsm_dbus_client_get_bus_name (GSM_DBUS_CLIENT (client));
+                } else {
+                        bus_name = NULL;
+                }
+
+                app_id = g_strdup (gsm_client_peek_app_id (client));
+                if (IS_STRING_EMPTY (app_id)) {
+                        /* XSMP clients don't give us an app id unless we start them */
+                        g_free (app_id);
+                        app_id = gsm_client_get_app_name (client);
+                }
+
+                cookie = _generate_unique_cookie (manager);
                 inhibitor = gsm_inhibitor_new_for_client (gsm_client_peek_id (client),
-                                                          gsm_client_peek_app_id (client),
+                                                          app_id,
                                                           GSM_INHIBITOR_FLAG_LOGOUT,
                                                           reason != NULL ? reason : _("Not responding"),
-                                                          gsm_client_peek_bus_name (client),
-                                                          _generate_unique_cookie (manager));
-                gsm_store_add (manager->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
+                                                          bus_name,
+                                                          cookie);
+                g_free (app_id);
+                gsm_store_add (priv->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
                 g_object_unref (inhibitor);
         } else {
-                gsm_store_foreach_remove (manager->inhibitors,
+                gsm_store_foreach_remove (priv->inhibitors,
                                           (GsmStoreFunc)inhibitor_has_client_id,
                                           (gpointer)gsm_client_peek_id (client));
         }
 
-        if (manager->phase == GSM_MANAGER_PHASE_QUERY_END_SESSION) {
-                if (manager->query_clients == NULL)
+        if (priv->phase == GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+                if (priv->query_clients == NULL) {
                         query_end_session_complete (manager);
-        } else if (manager->phase == GSM_MANAGER_PHASE_END_SESSION) {
+                }
+        } else if (priv->phase == GSM_MANAGER_PHASE_END_SESSION) {
+                if (do_last) {
+                        /* This only makes sense if we're in part 1 of
+                         * GSM_MANAGER_PHASE_END_SESSION. Doing this in part 2
+                         * can only happen because of a buggy client that loops
+                         * wanting to be last again and again. The phase
+                         * timeout will take care of this issue. */
+                        priv->next_query_clients = g_slist_prepend (priv->next_query_clients,
+                                                                             client);
+                }
+
                 /* we can continue to the next step if all clients have replied
                  * and if there's no inhibitor */
-                if (manager->query_clients != NULL || gsm_manager_is_logout_inhibited (manager))
+                if (priv->query_clients != NULL
+                    || gsm_manager_is_logout_inhibited (manager)) {
                         return;
+                }
 
-                end_phase (manager);
+                if (priv->next_query_clients != NULL) {
+                        do_phase_end_session_part_2 (manager);
+                } else {
+                        end_phase (manager);
+                }
         }
 }
 
+static void
+on_client_end_session_response (GsmClient  *client,
+                                gboolean    is_ok,
+                                gboolean    do_last,
+                                gboolean    cancel,
+                                const char *reason,
+                                GsmManager *manager)
+{
+        _handle_client_end_session_response (manager,
+                                             client,
+                                             is_ok,
+                                             do_last,
+                                             cancel,
+                                             reason);
+}
+
 static void
 on_store_client_added (GsmStore   *store,
                        const char *id,
                        GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmClient *client;
 
         g_debug ("GsmManager: Client added: %s", id);
@@ -1077,7 +1979,7 @@ on_store_client_added (GsmStore   *store,
                           G_CALLBACK (on_client_end_session_response),
                           manager);
 
-        gsm_exported_manager_emit_client_added (manager->skeleton, id);
+        gsm_exported_manager_emit_client_added (priv->skeleton, id);
         /* FIXME: disconnect signal handler */
 }
 
@@ -1086,9 +1988,51 @@ on_store_client_removed (GsmStore   *store,
                          const char *id,
                          GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: Client removed: %s", id);
 
-        gsm_exported_manager_emit_client_removed (manager->skeleton, id);
+        gsm_exported_manager_emit_client_removed (priv->skeleton, id);
+}
+
+static void
+gsm_manager_set_client_store (GsmManager *manager,
+                              GsmStore   *store)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_return_if_fail (GSM_IS_MANAGER (manager));
+
+        if (store != NULL) {
+                g_object_ref (store);
+        }
+
+        if (priv->clients != NULL) {
+                g_signal_handlers_disconnect_by_func (priv->clients,
+                                                      on_store_client_added,
+                                                      manager);
+                g_signal_handlers_disconnect_by_func (priv->clients,
+                                                      on_store_client_removed,
+                                                      manager);
+
+                g_object_unref (priv->clients);
+        }
+
+
+        g_debug ("GsmManager: setting client store %p", store);
+
+        priv->clients = store;
+
+        if (priv->clients != NULL) {
+                g_signal_connect (priv->clients,
+                                  "added",
+                                  G_CALLBACK (on_store_client_added),
+                                  manager);
+                g_signal_connect (priv->clients,
+                                  "removed",
+                                  G_CALLBACK (on_store_client_removed),
+                                  manager);
+        }
 }
 
 static void
@@ -1097,7 +2041,26 @@ gsm_manager_set_property (GObject       *object,
                           const GValue  *value,
                           GParamSpec    *pspec)
 {
-        G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+        GsmManager *self = GSM_MANAGER (object);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (self);
+
+        switch (prop_id) {
+        case PROP_FAILSAFE:
+                gsm_manager_set_failsafe (self, g_value_get_boolean (value));
+                break;
+         case PROP_FALLBACK:
+                priv->is_fallback_session = g_value_get_boolean (value);
+                break;
+         case PROP_CLIENT_STORE:
+                gsm_manager_set_client_store (self, g_value_get_object (value));
+                break;
+        case PROP_SYSTEMD_MANAGED:
+                priv->systemd_managed = g_value_get_boolean (value);
+                break;
+        default:
+                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+                break;
+        }
 }
 
 static void
@@ -1107,10 +2070,20 @@ gsm_manager_get_property (GObject    *object,
                           GParamSpec *pspec)
 {
         GsmManager *self = GSM_MANAGER (object);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (self);
 
         switch (prop_id) {
+        case PROP_FAILSAFE:
+                g_value_set_boolean (value, priv->failsafe);
+                break;
         case PROP_SESSION_NAME:
-                g_value_set_string (value, self->session_name);
+                g_value_set_string (value, priv->session_name);
+                break;
+        case PROP_FALLBACK:
+                g_value_set_boolean (value, priv->is_fallback_session);
+                break;
+        case PROP_CLIENT_STORE:
+                g_value_set_object (value, priv->clients);
                 break;
         default:
                 G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
@@ -1118,6 +2091,14 @@ gsm_manager_get_property (GObject    *object,
         }
 }
 
+static gboolean
+_find_app_provides (const char *id,
+                    GsmApp     *app,
+                    const char *service)
+{
+        return gsm_app_provides (app, service);
+}
+
 static GObject *
 gsm_manager_constructor (GType                  type,
                          guint                  n_construct_properties,
@@ -1135,21 +2116,25 @@ static void
 update_inhibited_actions (GsmManager *manager,
                           GsmInhibitorFlag new_inhibited_actions)
 {
-        if (manager->inhibited_actions == new_inhibited_actions)
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->inhibited_actions == new_inhibited_actions)
                 return;
 
-        gsm_system_set_inhibitors (manager->system, new_inhibited_actions);
+        gsm_system_set_inhibitors (priv->system, new_inhibited_actions);
 
-        manager->inhibited_actions = new_inhibited_actions;
-        gsm_exported_manager_set_inhibited_actions (manager->skeleton,
-                                                    manager->inhibited_actions);
+        priv->inhibited_actions = new_inhibited_actions;
+        gsm_exported_manager_set_inhibited_actions (priv->skeleton,
+                                                    priv->inhibited_actions);
 }
 
 static void
 on_inhibitor_vanished (GsmInhibitor *inhibitor,
                        GsmManager   *manager)
 {
-        gsm_store_remove (manager->inhibitors, gsm_inhibitor_peek_id (inhibitor));
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        gsm_store_remove (priv->inhibitors, gsm_inhibitor_peek_id (inhibitor));
 }
 
 static void
@@ -1157,6 +2142,7 @@ on_store_inhibitor_added (GsmStore   *store,
                           const char *id,
                           GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *i;
         GsmInhibitorFlag new_inhibited_actions;
 
@@ -1164,12 +2150,12 @@ on_store_inhibitor_added (GsmStore   *store,
 
         i = GSM_INHIBITOR (gsm_store_lookup (store, id));
 
-        new_inhibited_actions = manager->inhibited_actions | gsm_inhibitor_peek_flags (i);
+        new_inhibited_actions = priv->inhibited_actions | gsm_inhibitor_peek_flags (i);
         update_inhibited_actions (manager, new_inhibited_actions);
 
         g_signal_connect_object (i, "vanished", G_CALLBACK (on_inhibitor_vanished), manager, 0);
 
-        gsm_exported_manager_emit_inhibitor_added (manager->skeleton, id);
+        gsm_exported_manager_emit_inhibitor_added (priv->skeleton, id);
 
         update_idle (manager);
 }
@@ -1191,21 +2177,22 @@ on_store_inhibitor_removed (GsmStore   *store,
                             const char *id,
                             GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitorFlag new_inhibited_actions;
 
         g_debug ("GsmManager: Inhibitor removed: %s", id);
 
         new_inhibited_actions = 0;
-        gsm_store_foreach (manager->inhibitors,
+        gsm_store_foreach (priv->inhibitors,
                            collect_inhibition_flags,
                            &new_inhibited_actions);
         update_inhibited_actions (manager, new_inhibited_actions);
 
-        gsm_exported_manager_emit_inhibitor_removed (manager->skeleton, id);
+        gsm_exported_manager_emit_inhibitor_removed (priv->skeleton, id);
 
         update_idle (manager);
 
-        if (manager->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
                 end_session_or_show_shell_dialog (manager);
         }
 }
@@ -1214,51 +2201,57 @@ static void
 gsm_manager_dispose (GObject *object)
 {
         GsmManager *manager = GSM_MANAGER (object);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
 
         g_debug ("GsmManager: disposing manager");
 
-        g_clear_object (&manager->end_session_cancellable);
-        g_clear_pointer (&manager->session_name, g_free);
+        g_clear_object (&priv->end_session_cancellable);
+        g_clear_pointer (&priv->session_name, g_free);
 
-        if (manager->clients != NULL) {
-                g_signal_handlers_disconnect_by_func (manager->clients,
+        if (priv->clients != NULL) {
+                g_signal_handlers_disconnect_by_func (priv->clients,
                                                       on_store_client_added,
                                                       manager);
-                g_signal_handlers_disconnect_by_func (manager->clients,
+                g_signal_handlers_disconnect_by_func (priv->clients,
                                                       on_store_client_removed,
                                                       manager);
-                g_object_unref (manager->clients);
-                manager->clients = NULL;
+                g_object_unref (priv->clients);
+                priv->clients = NULL;
         }
 
-        g_clear_object (&manager->apps);
+        g_clear_object (&priv->apps);
+        g_slist_free (priv->required_apps);
+        priv->required_apps = NULL;
+        g_slist_free (priv->pending_apps);
+        priv->pending_apps = NULL;
 
-        if (manager->inhibitors != NULL) {
-                g_signal_handlers_disconnect_by_func (manager->inhibitors,
+        if (priv->inhibitors != NULL) {
+                g_signal_handlers_disconnect_by_func (priv->inhibitors,
                                                       on_store_inhibitor_added,
                                                       manager);
-                g_signal_handlers_disconnect_by_func (manager->inhibitors,
+                g_signal_handlers_disconnect_by_func (priv->inhibitors,
                                                       on_store_inhibitor_removed,
                                                       manager);
 
-                g_object_unref (manager->inhibitors);
-                manager->inhibitors = NULL;
+                g_object_unref (priv->inhibitors);
+                priv->inhibitors = NULL;
         }
 
-        g_clear_object (&manager->presence);
-        g_clear_object (&manager->settings);
-        g_clear_object (&manager->session_settings);
-        g_clear_object (&manager->lockdown_settings);
-        g_clear_object (&manager->system);
-        g_clear_object (&manager->shell);
+        g_clear_object (&priv->presence);
+        g_clear_object (&priv->settings);
+        g_clear_object (&priv->session_settings);
+        g_clear_object (&priv->screensaver_settings);
+        g_clear_object (&priv->lockdown_settings);
+        g_clear_object (&priv->system);
+        g_clear_object (&priv->shell);
 
-        if (manager->skeleton != NULL) {
-                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (manager->skeleton),
-                                                                    manager->connection);
-                g_clear_object (&manager->skeleton);
+        if (priv->skeleton != NULL) {
+                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (priv->skeleton),
+                                                                    priv->connection);
+                g_clear_object (&priv->skeleton);
         }
 
-        g_clear_object (&manager->connection);
+        g_clear_object (&priv->connection);
 
         G_OBJECT_CLASS (gsm_manager_parent_class)->dispose (object);
 }
@@ -1273,6 +2266,29 @@ gsm_manager_class_init (GsmManagerClass *klass)
         object_class->constructor = gsm_manager_constructor;
         object_class->dispose = gsm_manager_dispose;
 
+        signals [PHASE_CHANGED] =
+                g_signal_new ("phase-changed",
+                              G_TYPE_FROM_CLASS (object_class),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GsmManagerClass, phase_changed),
+                              NULL, NULL, NULL,
+                              G_TYPE_NONE,
+                              1, G_TYPE_STRING);
+
+        g_object_class_install_property (object_class,
+                                         PROP_FAILSAFE,
+                                         g_param_spec_boolean ("failsafe",
+                                                               NULL,
+                                                               NULL,
+                                                               FALSE,
+                                                               G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+        /**
+         * GsmManager::session-name
+         *
+         * Then name of the currently active session, typically "gnome" or "gnome-fallback".
+         * This may be the name of the configured default session, or the name of a fallback
+         * session in case we fell back.
+         */
         g_object_class_install_property (object_class,
                                          PROP_SESSION_NAME,
                                          g_param_spec_string ("session-name",
@@ -1280,6 +2296,36 @@ gsm_manager_class_init (GsmManagerClass *klass)
                                                               NULL,
                                                               NULL,
                                                               G_PARAM_READABLE));
+
+        /**
+         * GsmManager::fallback
+         *
+         * If %TRUE, the current session is running in the "fallback" mode;
+         * this is distinct from whether or not it was configured as default.
+         */
+        g_object_class_install_property (object_class,
+                                         PROP_FALLBACK,
+                                         g_param_spec_boolean ("fallback",
+                                                               NULL,
+                                                               NULL,
+                                                               FALSE,
+                                                               G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+        g_object_class_install_property (object_class,
+                                         PROP_CLIENT_STORE,
+                                         g_param_spec_object ("client-store",
+                                                              NULL,
+                                                              NULL,
+                                                              GSM_TYPE_STORE,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+        g_object_class_install_property (object_class,
+                                         PROP_SYSTEMD_MANAGED,
+                                         g_param_spec_boolean ("systemd-managed",
+                                                               NULL,
+                                                               NULL,
+                                                               FALSE,
+                                                               G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
 }
 
 static void
@@ -1298,20 +2344,23 @@ on_presence_status_changed (GsmPresence  *presence,
 static void
 on_gsm_system_active_changed (GsmSystem  *system,
                               GParamSpec *pspec,
-                              GsmManager *manager)
+                              GsmManager *self)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (self);
         gboolean is_active;
 
-        is_active = gsm_system_is_active (manager->system);
+        is_active = gsm_system_is_active (priv->system);
 
         g_debug ("emitting SessionIsActive");
-        gsm_exported_manager_set_session_is_active (manager->skeleton, is_active);
+        gsm_exported_manager_set_session_is_active (priv->skeleton, is_active);
 }
 
 static gboolean
 _log_out_is_locked_down (GsmManager *manager)
 {
-        return g_settings_get_boolean (manager->lockdown_settings,
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        return g_settings_get_boolean (priv->lockdown_settings,
                                        KEY_DISABLE_LOG_OUT);
 }
 
@@ -1328,16 +2377,60 @@ complete_end_session_task (GsmManager            *manager,
                 g_dbus_method_invocation_return_value (invocation, NULL);
 }
 
+static void
+request_reboot (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_debug ("GsmManager: requesting reboot");
+
+        /* FIXME: We need to support a more structured shutdown here,
+         * but that's blocking on an improved ConsoleKit api.
+         *
+         * See https://bugzilla.gnome.org/show_bug.cgi?id=585614
+         */
+        priv->logout_type = GSM_MANAGER_LOGOUT_REBOOT_INTERACT;
+        end_phase (manager);
+}
+
+static void
+request_shutdown (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_debug ("GsmManager: requesting shutdown");
+
+        /* See the comment in request_reboot() for some more details about
+         * what work needs to be done here. */
+        priv->logout_type = GSM_MANAGER_LOGOUT_SHUTDOWN_INTERACT;
+        end_phase (manager);
+}
+
+static void
+request_logout (GsmManager           *manager,
+                GsmManagerLogoutMode  mode)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_debug ("GsmManager: requesting logout");
+
+        priv->logout_mode = mode;
+        priv->logout_type = GSM_MANAGER_LOGOUT_LOGOUT;
+
+        end_phase (manager);
+}
+
 static gboolean
 gsm_manager_shutdown (GsmExportedManager    *skeleton,
                       GDBusMethodInvocation *invocation,
                       GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GTask *task;
 
         g_debug ("GsmManager: Shutdown called");
 
-        if (manager->phase < GSM_MANAGER_PHASE_RUNNING) {
+        if (priv->phase < GSM_MANAGER_PHASE_RUNNING) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_RUNNING,
